package dnddemo2;
import java.awt.Color;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import javax.swing.JComponent;
import javax.swing.TransferHandler;
import javax.swing.text.JTextComponent;

class TextColorTransferHandler extends TransferHandler {

    public int getSourceActions(JComponent c) {
        return COPY_OR_MOVE;
    }

    protected Transferable createTransferable(
            JComponent component) {
        String text = ((JTextComponent) component).getText();
        Color color = component.getForeground();
        TextColor transferable = new TextColor( text,color );
        return transferable;
    }

    public boolean canImport(JComponent c, DataFlavor[] flavors) {
        return true;
    }

    public boolean importData(JComponent component, 
                Transferable transferable) {
        String colorMimeType = DataFlavor.javaJVMLocalObjectMimeType
                + ";class=java.awt.Color";
        JTextComponent textComponent = (JTextComponent) component;
        try {
            DataFlavor colorFlavor = new DataFlavor(colorMimeType);
            Color color = (Color) transferable.getTransferData(
                    colorFlavor );
            String text = (String) transferable
                    .getTransferData( DataFlavor.stringFlavor );
            textComponent.setForeground(color);
            textComponent.setText(text);
        }
        catch( Exception e ) {
            e.printStackTrace();
        }
        return true;
    }
}
